## Install steps  

0) Go into the folder in which you want to create the qtg repo  
1) Copy tools/archive.src into CodeEditor, then as archive.src  
2) Execute:  
build archive.src /bin  
- archive is now available on the system  
You can delete archive.src  
3) Copy archives/qtg.tar.part1 and .part2 into Notepad, then as REPO_NAME.tar.part1 and .part2
- archive checks for the .tar extention!  
4) Execute:  
archive REPO_NAME  
- The folder REPO_NAME is now created  
You can now delete the tar files
5) Copy the libs folder into all folders to make sure the .gs scripts are able to find them  
6) Execute:  
build preprocess.src /bin  
preprocess is now available on the system to process .gs files  
7) Execute:  
cd tools  
preprocess archive.src  
This way, you'll have an archive tool which use the libs from the archive :P  


## How does the preprocessor work?

It is very simple, it detects the `"#import file.gs”` pattern and includes the file at this place (it consists of `#import` with a file, between quotes, and must be at the begining of a line).

We decided that the “importable” files should have a `.gs` extension, and the result of the preprocessor is stored as `file_pp.src`. Then it is compiled and the source file is removed. The executable file is created with no extension.

The preprocessor is also able to remove everything located after a line starting with `“#UnitTests“` to be able to add tests to our files without including them into final executable files.

Warning: the preprocessor does not remove the Grey Hack limitation of 80000 characters for a compilable script.